#include <caml/mlvalues.h>
#include <caml/memory.h>
#include <caml/callback.h>
#include <caml/custom.h>
#include <caml/alloc.h>
#include <caml/bigarray.h>
#include <caml/fail.h>
#include <caml/intext.h>
#include <stdio.h>

CAMLprim value read_double (value in_chan) {
  CAMLparam1 (in_chan);
  CAMLlocal1 (dbl);
  double x = 0.;
  static value *endof = NULL;
  int nbread = read (((struct channel *)(Channel(in_chan)))->fd, &x, sizeof(double));
  if (nbread != sizeof(double)) {
    if (!endof) endof = caml_named_value ("End_of_file");
    raise_constant (*endof);
  }
  dbl = alloc_small (Double_wosize, Double_tag);
  Store_double_val (dbl, x);
  CAMLreturn (dbl);
}
